// convert 0.1 - russian codepage converter

#include<iostream.h>
#include<fstream.h>
#include<stdlib.h>
#include<stdio.h>
#include<fcntl.h>
#include<io.h>

typedef unsigned char byte;

void finish(char* msg){
	cerr << "FATAL ERROR: " << msg << '\n';
	exit(1);
}

#define CP_SIZE 66

byte cp1data[CP_SIZE];
byte cp2data[CP_SIZE];

byte cnvdata[256];

void load_cpdata(byte* cpdata,char* cpfname) {

	int fd,bytes_read;
	printf("Loading codepage: %s\n",cpfname);
	fd = open(cpfname,O_RDONLY);
	if(fd < 0)
		finish("Can't open codepage file");

	bytes_read = read(fd,cpdata,CP_SIZE);
	if(bytes_read != CP_SIZE)
		finish("Can't load codepage");
	close(fd);
}

// -------------------------------------------
void init_cnvdata() {

 int i,k;

for(i = 0; i < 256; i ++)
	cnvdata[i] = i;

 for(i = 0; i < CP_SIZE; i ++)
   cnvdata[cp1data[i]] = cp2data[i];

}


inline int convert(int c) {
	byte b = c;	
	return cnvdata[b];
	
}

// --------------------------------------------

int main(int argc,char *argv[]) {
	int cnt;
	int c;
	char *cp1,*cp2;
	char *name1,*name2;
	if(argc != 5)
		finish("4 arguments expected");
	
	cp1 = argv[1];
	name1 = argv[2];
	cp2 = argv[3];
	name2 = argv[4];
	
	ifstream in(name1,ios::binary | ios::nocreate);
	ofstream out(name2,ios::binary);

	if(!in.good())
		finish("Input stream not good");
	if(!out.good())
		finish("Output stream not good");
	
	load_cpdata(cp1data,cp1);
	load_cpdata(cp2data,cp2);
	init_cnvdata();

	cnt = 0;
	while(!in.eof()) {
		c = in.get();
		if(c == -1)
			break;
		c = convert(c);
		out.put((char)c);
		cnt ++;
		}

	printf("Done, %d characters\n",cnt);
	return 0;
}
